;##################################################################
; DEMO EXTRACT ICON
;##################################################################

#include "C:\GoAsm\IncludeA\WINDOWS.inc"
#include "C:\GoAsm\IncludeA\all_api.inc"
#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

GRPICONDIR Struct
	idReserved	DW ; Reserved (must be 0)
	idType		DW ; Resource type (1 for icons)
	idCount		DW ; How many images?
	;   GRPICONDIRENTRY   idEntries[1] ; The entries for each image
ENDS

GRPICONDIRENTRY struct
	bWidth		DB ; Width, in pixels, of the image
	bHeight		DB ; Height, in pixels, of the image
	bColorCount	DB ; Number of colors in image (0 if >=8bpp)
	bReserved	DB ; Reserved
	wPlanes		DW ; Color Planes
	wBitCount	DW ; Bits per pixel
	dwBytesInRes	DD ; how many bytes in this resource?
	nID			DW ; the ID
ENDS

ICONDIR struct
	idReserved	DW ; Reserved (must be 0)
	idType		DW ; Resource Type (1 for icons)
	idCount		DW ; How many images?
	;    ICONDIRENTRY   idEntries[1]; An entry for each image
ENDS

ICONDIRENTRY struct
	bWidth		DB ; Width, in pixels, of the image
	bHeight		DB ; Height, in pixels, of the image
	bColorCount	DB ; Number of colors in image (0 if >=8bpp)
	bReserved	DB ;  Reserved ( must be 0)
	wPlanes		DW ; Color Planes
	wBitCount	DW ; Bits per pixel
	dwBytesInRes	DD ; How many bytes in this resource?
	dwImageOffset	DD ; Where in the file is this image?
ENDS

.DATA
	hInst				DD	0
	szTestFile			DB	"Test.ico",0
	szshell32			DB	"\shell32.dll",0
	hLibFile			DD	0
	dwNDX				DD	0
	szTargetFile		DB	MAX_PATH DUP (0)
	nIconsInFile		DD	0
	pIconList			DD	0

.CODE

Start:
	invoke GetModuleHandle, 0
	mov [hInst],eax
	invoke GetSystemDirectory,OFFSET szTargetFile,MAX_PATH
	invoke lstrcat,OFFSET szTargetFile,OFFSET szshell32
	invoke DialogBoxParam,[hInst],1000,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL hIcoFile	:D

	mov eax,[uMsg]

	.WMINITDIALOG
		cmp eax,WM_INITDIALOG
		jne >.WMCOMMAND

		jmp >>.EXIT

	.WMCOMMAND
		cmp eax,WM_COMMAND
		jne >>.WMCLOSE
		; Find out how many icons there are and create a buffer for the res names
		invoke ExtractIcon,[hInst],ADDR szTargetFile,-1
		mov [nIconsInFile],eax
		or eax,eax
		jz >>.EXIT
		shl eax,6
		invoke GlobalAlloc,GMEM_ZEROINIT,eax
		mov [pIconList],eax

		; load the file as a library
		invoke LoadLibraryEx,ADDR szTargetFile,NULL,LOAD_LIBRARY_AS_DATAFILE
		mov [hLibFile],eax
		invoke BuildIndexTable,[pIconList]
		or eax,eax
		jz >
		invoke CreateFile,OFFSET szTestFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
		mov [hIcoFile],eax

		mov eax,10 ; index number
		shl eax,6
		add eax,[pIconList]
		invoke SaveIconResource,[hLibFile],eax,[hIcoFile]
		:
		invoke FreeLibrary,[hLibFile]
		invoke GlobalFree,[pIconList]
		jmp >.EXIT

	.WMCLOSE
		cmp eax,WM_CLOSE
		jne >.DEFPROC
		invoke EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		ret

	.EXIT

	xor eax,eax
	inc eax
	ret
ENDF

;hModule = module handle returned from LoadLibraryEx
;pResName = reource identifier for RT_GROUP_ICON resource
;hFile = Handle to the output file (*.ico)

SaveIconResource FRAME hModule,pResName,hFile
	uses edi,esi
	LOCAL hFindRes		:D
	LOCAL hResData		:D
	LOCAL pResData		:D
	LOCAL ResSize		:D
	LOCAL iCount		:D
	LOCAL pOutput		:D
	LOCAL cbWritten		:D
	LOCAL cbWrite		:D
	LOCAL iResName[16]	:B
	LOCAL StrOffset		:D

	invoke FindResource,[hModule],[pResName],RT_GROUP_ICON
	mov [hFindRes],eax
	invoke SizeofResource,[hModule],[hFindRes]
	mov [ResSize],eax
	or eax,eax
	jnz >
		dec eax
		ret
	:
	mov B[iResName],"#"

	invoke LoadResource,[hModule],[hFindRes]
	mov [hResData],eax
	invoke LockResource,[hResData]
	mov [pResData],eax
	or eax,eax
	jnz >
		dec eax
		ret
	:

	; Calculate the size of the file
	mov edi,eax
	xor ecx,ecx
	mov cx,[edi+GRPICONDIR.idCount]
	mov D[iCount],ecx
	add edi,SIZEOF GRPICONDIR
	mov eax,SIZEOF GRPICONDIR
	:
		add eax,[edi+GRPICONDIRENTRY.dwBytesInRes]
		add eax,SIZEOF GRPICONDIRENTRY
		add edi,SIZEOF GRPICONDIRENTRY
	dec ecx
	jnz <

	mov ecx,[iCount]
	shl ecx,1
	add eax,ecx
	mov [cbWrite],eax
	invoke GlobalAlloc,GPTR,eax
	mov [pOutput],eax
	
	mov esi,[pResData]
	mov edi,[pOutput]
	; Copy the header
	invoke memcopy,[pResData],[pOutput],SIZEOF GRPICONDIR
	; Move the pointers up
	add esi,SIZEOF GRPICONDIR
	add edi,SIZEOF GRPICONDIR
	; Copy the array of Icon dir entries
	xor ecx,ecx
	:
		; Copy the icon entry
		invoke memcopy,esi,edi,SIZEOF GRPICONDIRENTRY
		; mov the pointers up
		add esi,SIZEOF GRPICONDIRENTRY
		add edi,SIZEOF GRPICONDIRENTRY
		; An extra 2 for the destination index
		add edi,2
		inc ecx
	cmp ecx,[iCount]
	jne <

	xor ecx,ecx
	; reset the source index to the first GRPICONDIRENTRY
	mov esi,[pResData]
	add esi,SIZEOF GRPICONDIR
	; reset the Destination index to the first ICONDIRENTRY
	mov eax,[pOutput]
	add eax,SIZEOF GRPICONDIR
	mov [StrOffset],eax

	:
		push ecx
		; Get the id of the icon
		lea ecx,[iResName]
		inc ecx
		movzx eax,W[esi+GRPICONDIRENTRY.nID]
		invoke dwordtoascii,eax,ecx

		; Get a copy of the icon resource
		invoke FindResource,[hModule],ADDR iResName,RT_ICON
		mov [hFindRes],eax
		invoke SizeofResource,[hModule],[hFindRes]
		mov [ResSize],eax
		invoke LoadResource,[hModule],[hFindRes]
		mov [hResData],eax
		invoke LockResource,[hResData]
		mov [pResData],eax

		; Copy the icon data to the buffer
		invoke memcopy,[pResData],edi,[esi+GRPICONDIRENTRY.dwBytesInRes]

		; move the offset of this data to the array
		mov ecx,edi
		sub ecx,[pOutput]
		mov eax,[StrOffset]
		mov [eax+ICONDIRENTRY.dwImageOffset],ecx
		add D[StrOffset],SIZEOF ICONDIRENTRY

		; Increment the destination pointer
		add edi,[esi+GRPICONDIRENTRY.dwBytesInRes]

		; Increment the source pointer
		add esi,SIZEOF GRPICONDIRENTRY
		pop ecx
		inc ecx
	cmp ecx,[iCount]
	jne <

	invoke WriteFile,[hFile],[pOutput],[cbWrite],ADDR cbWritten,NULL
	invoke FlushFileBuffers,[hFile]
	invoke CloseHandle,[hFile]

	invoke GlobalFree,[pOutput]
	mov eax,[cbWritten]
	ret

ENDF

BuildIndexTable FRAME pTable
	mov D[dwNDX],0
	invoke EnumResourceTypes,[hLibFile],OFFSET ResTypeEnumFunction,[pTable]
	mov eax,[dwNDX]
	RET
ENDF

ResTypeEnumFunction FRAME hModule,lpszType,lParam

	cmp D[lpszType],RT_GROUP_ICON
	jne >
	invoke EnumResourceNames,[hLibFile],[lpszType],OFFSET ResEnumFunction,[lParam]
	:
	xor eax,eax
	inc eax
	ret
ENDF

ResEnumFunction FRAME hModule,lpType,lpName,lParam
	LOCAL rsName[64]		:B
	LOCAL IconIndex			:D

	mov eax,[lpName]
	shr eax,16
	or ax,ax
	jnz >
		lea ecx,rsName
		mov B[ecx],"#"
		inc ecx
		invoke dwordtoascii,[lpName],ecx
		jmp >L1
	:
		invoke lstrcpy,ADDR rsName,[lpName]
	L1:

	cmp D[lpType],RT_GROUP_ICON
	jne >
		mov eax,[dwNDX]
		shl eax,6
		add eax,[lParam]
		invoke lstrcpy,eax,ADDR rsName
		inc D[dwNDX]
	:
	xor eax,eax
	inc eax
	ret
ENDF

memcopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]
	
	; do the evenly divisible ones
	shr ecx,2
	rep movsd
	
	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb
	
	RET
ENDF

dwordtoascii FRAME dwValue, lpBuffer
	
	push ebx
	push esi
	push edi

	mov eax, [dwValue]
	mov edi, [lpBuffer]

	or eax,eax
	jnz >L2 ; sign

	L1: ; zero:
		mov W[edi],30h
		jmp >L8

	L2: ; sign:
		jns >L3 ; pos
		mov B[edi],'-'
		neg eax
		inc edi

	L3: ; pos:      
		mov ecx,429496730
		mov esi, edi

	jmp >L5
	L4:
		mov ebx,eax
		mul ecx
		mov eax,edx
		lea edx,[edx*4+edx]
		add edx,edx
		sub ebx,edx
		add bl,'0'
		mov [edi],bl
		inc edi
	L5:
	cmp eax,0
	jg <L4

	mov B[edi], 0
	
	jmp >L7
	L6:
		dec edi
		mov al, [esi]
		mov ah, [edi]
		mov [edi], al
		mov [esi], ah
		inc esi
	L7:
	cmp esi,edi
	jl <L6

	L8:

	pop edi
	pop esi
	pop ebx

	RET
ENDF
